<template>
  <div id="app" class="ui fluid container">
    <div class="ui grid">
      <div class="two column row top">
        <div class="column">
          <h2 class="ui center aligned icon header">
            <i class="circular bug icon"></i>
            One way payment channel debugger
          </h2>
          <p class="align-center">This is a quick demo for the TrueLevel payment channels library.</p>
          <p class="align-center">This demo contains: (1) setup the parameters needed for a payment channel, (2) open the channel on-chain, (3) make transactions throught the channel, (4) refund by the client, (5) settle by provider, (6) spend or revoke.</p>
          <p class="align-center">This demo DOES NOT contains: (1) withdraw an amount from the channel, (2) make transactions throught the channel after settlement [only close by client is available], (3) cooperative close.</p>
        </div>
        <div class="column options">
          <h3 class="ui header">Channel settings</h3>
          <form class="ui form">
            <div class="field" v-bind:class="{ disabled: channelIsSetup }">
              <label>Network</label>
              <select class="ui dropdown" v-model="settings.network">
                  <!--<option value="bitcoin">Bitcoin</option>-->
                <option value="testnet" selected>Testnet</option>
              </select>
            </div>
            <div class="field" v-bind:class="{ disabled: channelIsSetup }">
              <label>Channel account number</label>
              <div class="ui left icon input">
                <i class="bullhorn icon"></i>
                <input type="text" name="account-id" v-model="settings.accountId" placeholder="e.g 4">
              </div>
            </div>
            <div class="field" v-bind:class="{ disabled: channelIsSetup }">
              <label>Locktime (blocks in future)</label>
              <div class="ui left icon input">
                <i class="history icon"></i>
                <input type="text" name="block-in-future" v-model="settings.blocksInFuture" placeholder="e.g 2">
              </div>
            </div>
            <div class="field" v-bind:class="{ disabled: channelIsSetup }">
              <label>Fee per byte</label>
              <div class="ui left icon input">
                <i class="bitcoin icon"></i>
                <input type="text" name="fee-per-byte" v-model="settings.feePerByte" placeholder="e.g 5">
              </div>
            </div>
          </form>
          <div class="ui hidden divider" v-if="isSettingsComplete"></div>
          <div v-if="isSettingsComplete">
            <form class="ui form">
              <div class="field" v-bind:class="{ disabled: channelIsSetup }">
                <label>Client root seed</label>
                <div class="ui labeled input">
                  <div class="ui label">
                    m/
                  </div>
                  <input name="client-seed" v-model="settings.clientSeed" placeholder="Client seed" type="text">
                </div>
              </div>
            </form>
            <div class="ui inverted segment">
              <form class="ui inverted form">
                <div class="field">
                  <label>Client Pubkey Account</label>
                  <div class="ui labeled input">
                    <div class="ui label">
                      m/44'/0'/{{settings.accountId}}'
                    </div>
                    <input name="client-pubkey" v-model="settings.clientAccPubkey" readonly type="text">
                  </div>
                </div>
              </form>
            </div>
            <form class="ui form">
              <div class="field" v-bind:class="{ disabled: channelIsSetup }">
                <label>Provider root seed</label>
                <div class="ui labeled input">
                  <div class="ui label">
                    m/
                  </div>
                  <input name="provider-seed" v-model="settings.providerSeed" placeholder="Provider seed" type="text">
                </div>
              </div>
            </form>
            <div class="ui inverted segment">
              <form class="ui inverted form">
                <div class="field">
                  <label>Provider Pubkey Account</label>
                  <div class="ui labeled input">
                    <div class="ui label">
                      m/44'/0'/{{settings.accountId}}'
                    </div>
                    <input name="provider-pubkey" v-model="settings.providerAccPubkey" readonly type="text">
                  </div>
                </div>
              </form>
            </div>
              <button class="ui button positive"
                v-if="settings.network && settings.accountId && settings.blocksInFuture && settings.clientSeed && settings.providerSeed"
                v-bind:class="{ disabled: channelIsSetup }"
                type="button"
                @click.prevent="setup">Setup the channel</button>

              <button class="ui primary button"
                v-if="settings.network && settings.accountId && settings.blocksInFuture && settings.clientSeed && settings.providerSeed"
                v-bind:class="{ loading: settings.storing }"
                type="button"
                data-content="You can store the current settings to reuse it later."
                @click.prevent="storeSettings">Store settings</button>

              <button class="ui button"
                v-bind:class="{ disabled: channelIsSetup }"
                type="button"
                @click.prevent="seeds">Generate new seeds</button>

            </div>
            <div v-if="!settings.network && !settings.accountId && restored">
              <div class="ui hidden divider"></div>
              <div class="ui buttons">
                <button class="ui primary button"
                  v-bind:class="{ disabled: channelIsSetup }"
                  type="button"
                  data-content="You can restore settings for a previous session."
                  @click.prevent="loadSettings">Restore settings</button>
                <div class="or"></div>
                <button class="ui negative button"
                  v-bind:class="{ disabled: channelIsSetup }"
                  type="button"
                  data-content="The previous session will be permanently removed from your storage."
                  @click.prevent="removeSaves">Remove saved settings</button>
              </div>
            </div>
          </form>
        </div>
      </div>

      <div class="ui section divider"></div>

      <div class="two column divided row" v-if="channelIsSetup">
        <div class="column">
          <h3 class="ui header">Opening of the channel</h3>
          <form class="ui form">
            <div class="ui message">
              <div class="header">
                Client settings
              </div>
              <p>We create an address controled by the client to be able to spend some UTXOs into the funding multisig address.
              This step will be replaced by an internal behavior in the final wallet.</p>
            </div>
            <div class="field" v-bind:class="{ disabled: channelIsOpen }">
              <label>Client path</label>
              <div class="ui labeled input">
                <div class="ui label">
                  m/44'/0'/1'/0/
                </div>
                <input placeholder="1" v-model="opening.path" type="text">
              </div>
            </div>
            <div class="field">
              <div class="ui labeled input">
                <div class="ui label">
                  WIF
                </div>
                <input readonly value="" v-model="opening.wif" type="text">
              </div>
            </div>
          </form>
          <div class="ui inverted segment">
            <form class="ui inverted form">
              <div class="field">
                <label>Client address</label>
                <div class="ui left icon input">
                  <i class="unlock crosshairs icon"></i>
                  <input name="address" readonly value="" v-model="opening.address" type="text">
                </div>
              </div>
            </form>
          </div>

          <form class="ui form">
            <div class="ui message">
              <div class="header">
                Provider settings
              </div>
              <p>We create an address controled by the provider to be the settlement address.</p>
            </div>
            <div class="field" v-bind:class="{ disabled: channelIsOpen }">
              <label>Provider settlement path</label>
              <div class="ui labeled input">
                <div class="ui label">
                  m/44'/0'/1'/0/
                </div>
                <input placeholder="1" v-model="opening.provider.path" type="text">
              </div>
            </div>
            <div class="field">
              <div class="ui labeled input">
                <div class="ui label">
                  WIF
                </div>
                <input readonly value="" v-model="opening.provider.wif" type="text">
              </div>
            </div>
          </form>
          <div class="ui inverted segment">
            <form class="ui inverted form">
              <div class="field">
                <label>Provider settlement address</label>
                <div class="ui left icon input">
                  <i class="unlock crosshairs icon"></i>
                  <input name="address" readonly value="" v-model="opening.provider.address" type="text">
                </div>
              </div>
            </form>
          </div>

          <button class="ui labeled icon button"
            @click.prevent="getProviderUtxos"
            v-bind:class="{ loading: opening.loadingProviderUtxos}">
            <i class="refresh icon"></i>
            Load provider UTXOs
          </button>

          <h3 class="ui header" v-if="opening.provider.utxos.length > 0">
            UTXOs for address {{opening.provider.address}}
          </h3>
          <div class="ui tiny statistics" v-if="opening.provider.utxos.length > 0">
            <div class="statistic">
              <div class="value">
                {{ opening.provider.utxos.length }}
              </div>
              <div class="label">
                UTXOs
              </div>
            </div>
            <div class="statistic">
              <div class="value">
                {{ this.opening.provider.amount }}
              </div>
              <div class="label">
                Satoshis
              </div>
            </div>
          </div>
          <div class="ui inverted segment" v-if="opening.provider.utxos.length > 0">
            <div class="ui inverted relaxed divided list">
              <div class="item" v-for="utxo in opening.provider.utxos">
                <div class="content">
                  <div class="header">{{ utxo.txid }} <i class="icon hashtag"></i> {{ utxo.vout }}</div>
                  ScriptPubKey: {{ utxo.scriptPubKey }}<br>
                  Amount: {{ utxo.amount.satoshis() }}
                </div>
              </div>
            </div>
          </div>

          <button class="ui green button"
            v-if="opening.provider.utxos.length > 0"
            type="button"
            v-bind:class="{ loading: opening.broadcastingProviderToClient }"
            @click.prevent="sendUtxosFromProviderToAddress(opening.address)">Send UTXOs to {{ opening.address }}</button>

          <button class="ui button"
            v-if="opening.provider.utxos.length > 0 && !opening.sendToExitAddress"
            type="button"
            @click.prevent="opening.sendToExitAddress = true">Send to another address</button>

          <h3 class="ui header" v-if="opening.provider.utxos.length > 0 && opening.sendToExitAddress">Send to exit address</h3>
          <div class="ui inverted segment" v-if="opening.provider.utxos.length > 0 && opening.sendToExitAddress">
            <form class="ui inverted form">
              <div class="field">
                <label>Exit address</label>
                <div class="ui left icon input">
                  <i class="unlock crosshairs icon"></i>
                  <input name="address" value="" v-model="opening.exitAddress" type="text">
                </div>
              </div>
            </form>
          </div>

          <button class="ui green button"
            v-if="opening.provider.utxos.length > 0 && opening.exitAddress"
            type="button"
            v-bind:class="{ loading: opening.broadcastingProviderToClient }"
            @click.prevent="sendUtxosFromProviderToAddress(opening.exitAddress)">Send</button>

          <h3 class="ui header" v-if="channelIsOpen && !channelIsClosing">Channel reset</h3>
          <form class="ui form" v-if="channelIsOpen && !channelIsClosing">
            <div class="ui message">
              <div class="header">
                Reseting the channel
              </div>
              <p>Empty the multisig address and send all the amount to the client address.</p>
            </div>
            <div class="field">
              <button class="ui negative button"
                v-if="!channelIsClosing"
                v-bind:class="{ loading: channelIsReseting }"
                @click.prevent="resetChannel">Reset channel</button>
            </div>
          </form>
        </div>

        <div class="column">
          <h3 class="ui header" v-if="!channelIsOpen">
            UTXOs for address {{opening.address}}
          </h3>
          <div class="ui tiny statistics" v-if="!channelIsOpen">
            <div class="statistic">
              <div class="value">
                {{ opening.utxos.length }}
              </div>
              <div class="label">
                UTXOs
              </div>
            </div>
            <div class="statistic">
              <div class="value">
                {{ this.opening.amount }}
              </div>
              <div class="label">
                Satoshis
              </div>
            </div>
            <div class="statistic">
              <div class="value">
                {{ this.openingBtc | bitcoin }}
              </div>
              <div class="label">
                 <i class="btc icon"></i>
              </div>
            </div>
          </div>
          <div class="ui inverted segment" v-if="opening.utxos.length > 0 && !channelIsOpen">
            <div class="ui inverted relaxed divided list">
              <div class="item" v-for="utxo in opening.utxos">
                <div class="content">
                  <div class="header">{{ utxo.txid }} <i class="icon hashtag"></i> {{ utxo.vout }}</div>
                  ScriptPubKey: {{ utxo.scriptPubKey }}<br>
                  Amount: {{ utxo.amount.satoshis() }}
                </div>
              </div>
            </div>
          </div>

          <div class="ui hidden divider" v-if="opening.utxos.length === 0 && !channelIsOpen"></div>
          <button class="ui labeled icon button"
            v-if="!channelIsOpen"
            @click.prevent="refreshFunding"
            v-bind:class="{ loading: opening.refreshing }">
            <i class="refresh icon"></i>
            Refresh
          </button>

          <div v-if="opening.utxos.length > 0 || channelIsOpen">
            <div class="ui hidden divider"></div>
            <form class="ui form">
              <h4 class="ui dividing header">Multisig settings</h4>
              <div class="field" v-bind:class="{ disabled: channelIsOpen }">
                <label>Starting i</label>
                <div class="ui left icon input">
                  <i class="unlock cube icon"></i>
                  <input name="i" placeholder="e.g 0" v-model="opening.i" type="text">
                </div>
              </div>
              <div class="field" v-bind:class="{ disabled: channelIsOpen }">
                <label>Starting n</label>
                <div class="ui left icon input">
                  <i class="unlock cube icon"></i>
                  <input name="i" placeholder="e.g 0" v-model="opening.n" type="text">
                </div>
              </div>
            </form>
            <div class="ui inverted segment">
              <form class="ui inverted form">
                <div class="field">
                  <label>Funding multisig address</label>
                  <div class="ui left icon input">
                    <i class="unlock crosshairs icon"></i>
                    <input name="address" readonly value="" v-model="opening.multisig.address" type="text">
                  </div>
                  <div class="ui inverted message no-padding wrap" v-if="opening.multisig.redeemScript">
                    <div class="header">Locking script:</div>
                    <p>{{ opening.multisig.redeemScript.toString('hex') }}</p>
                    <p>{{ opening.multisig.asm }}</p>
                  </div>
                </div>
              </form>
            </div>

              <button class="ui button"
                @click.prevent="createFundingTransaction"
                v-if="opening.utxos.length > 0 && opening.multisig.address && !funding.transaction"
                v-bind:class="{ loading: funding.pending }">Create funding transaction</button>

              <button class="ui button"
                type="button"
                v-if="opening.utxos.length > 0 && (opening.i == '' || opening.n == '')"
                @click.prevent="defaultState">Default settings</button>
          </div>

          <div v-if="funding.transaction">
            <div class="ui hidden divider"></div>
            <div class="ui cards">
              <div class="ui card">
                <div class="content wrap">
                  <div class="header">Revokation parameters</div>
                  <h4 class="ui sub header">Secret</h4>
                  <p v-if="funding.transaction.revSecret">{{ funding.transaction.revSecret }}</p>
                  <h4 class="ui sub header">Hash</h4>
                  <p v-if="funding.transaction.revPubkey.revHash">{{ funding.transaction.revPubkey.revHash }}</p>
                </div>
              </div>
              <div class="ui card">
                <div class="content wrap">
                  <div class="header">RevPupkey contract</div>
                  <h4 class="ui sub header">Address</h4>
                  <p>{{ funding.transaction.revPubkey.address }}</p>
                  <h4 class="ui sub header">Script</h4>
                  <p v-if="funding.transaction.revPubkey.redeemScript">{{ funding.transaction.revPubkey.redeemScript }}</p>
                  <h4 class="ui sub header">ASM</h4>
                  <p>{{ funding.transaction.revPubkey.asm }}</p>
                </div>
              </div>
            </div>
            <div class="ui inverted blue secondary segment wrap">
              <h4 class="ui sub header">Funding transaction (fully signed)</h4>
              <p>{{ funding.transaction.fundingTx.tx }}</p>
            </div>
            <div class="ui inverted segment wrap" v-if="!funding.refundSignedByServer">
              <h4 class="ui sub header">Refund transaction (not signed)</h4>
              <p>{{ funding.transaction.refundTx.tx }}</p>
            </div>
            <div class="ui inverted segment wrap" v-if="funding.refundSignedByServer && !funding.refundSignedByServerAndClient">
              <h4 class="ui sub header">Refund transaction (signed by server)</h4>
              <p>{{ funding.refundSignedByServer }}</p>
            </div>
            <div class="ui inverted blue secondary segment wrap" v-if="funding.refundSignedByServerAndClient">
              <h4 class="ui sub header">Refund transaction (fully signed)</h4>
              <p>{{ funding.refundSignedByServerAndClient }}</p>
            </div>

            <button class="ui button basic violet"
              @click.prevent="signRefundByServer"
              v-if="!funding.refundSignedByServer">Sign refund transaction (server)</button>

            <button class="ui positive button"
              v-if="this.funding.refundSignedByServer && !channelIsOpen"
              v-bind:class="{ loading: opening.pending }"
              @click.prevent="open">Open channel on-chain</button>

            <button class="ui button basic violet"
              @click.prevent="signRefundByClient"
              v-if="funding.refundSignedByServer && !funding.refundSignedByServerAndClient">Sign refund transaction (client)</button>
          </div>
        </div>
      </div>

      <div class="ui section divider" v-if="channelIsOpen"></div>
      <div class="row" v-if="channelIsOpen && !channelIsClosing">
        <div class="column">
          <div class="ui large green message">
            <div class="header">
              The channel is now open
            </div>
            <p>You can see on a block explorer the P2SH funding address {{ opening.multisig.address }}.</p>
          </div>
        </div>
      </div>

      <div class="row" v-if="channelIsOpen">
        <div class="column">
          <h2 class="ui header">Transactions</h2>
        </div>
      </div>
      <div class="row" v-if="channelIsOpen">
        <div class="column" v-if="transactions.length > 0">
          <div class="ui stacked segment full"
            v-for="transaction in transactions"
            v-bind:class="{ green: transaction.isComplete }">
            <div class="ui grid">
              <div class="row">
                <div class="column">
                  <div class="ui inverted segment" v-if="transaction.nextMultisig">
                    <form class="ui inverted form">
                      <div class="field">
                        <label>Next multisig address</label>
                        <div class="ui left icon input">
                          <i class="unlock crosshairs icon"></i>
                          <input name="address" readonly value="" v-model="transaction.nextMultisig.address" type="text">
                        </div>
                        <div class="ui inverted message no-padding wrap">
                          <div class="header">Locking script:</div>
                          <p>{{ transaction.nextMultisig.redeemScript }}</p>
                          <p>{{ transaction.nextMultisig.asm }}</p>
                        </div>
                      </div>
                    </form>
                  </div>
                  <div class="ui cards">
                    <div class="ui card inverted">
                      <div class="content wrap">
                        <div class="ui statistics">
                          <div class="statistic">
                            <div class="value">
                              {{ transaction.i.flatten() }}
                            </div>
                            <div class="label">
                              I
                            </div>
                          </div>
                          <div class="statistic">
                            <div class="value">
                              {{ transaction.n.flatten() }}
                            </div>
                            <div class="label">
                              N
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                    <div class="ui card">
                      <div class="content wrap">
                        <div class="header">Revokation parameters</div>
                        <h4 class="ui sub header">Secret</h4>
                        <p>{{ transaction.currentSecret }}</p>
                        <h4 class="ui sub header">Hash</h4>
                        <p>{{ transaction.revPubkey.revHash }}</p>
                        <h4 class="ui sub header" v-if="transaction.previousSecret">Previous secret</h4>
                        <p v-if="transaction.previousSecret">{{ transaction.previousSecret }}</p>
                      </div>
                    </div>
                    <div class="ui card" v-if="transaction.revPubkey">
                      <div class="content wrap">
                        <div class="header">RevPupkey contract</div>
                        <h4 class="ui sub header">Address</h4>
                        <p>{{ transaction.revPubkey.address }}</p>
                        <h4 class="ui sub header">Script</h4>
                        <p>{{ transaction.revPubkey.redeemScript }}</p>
                        <h4 class="ui sub header">ASM</h4>
                        <p>{{ transaction.revPubkey.asm }}</p>
                      </div>
                    </div>
                    <div class="ui card">
                      <div class="content wrap">
                        <div class="header">Payment infos</div>
                        <h4 class="ui sub header">Payment amount</h4>
                        <p>{{ transaction.paymentAmount }}</p>
                        <h4 class="ui sub header">Remaining statoshis in channel</h4>
                        <p>{{ send.totalInChannel - (transaction.providerAmount + transaction.paymentAmount) }}</p>
                        <h4 class="ui sub header">New provider balance</h4>
                        <p>{{ transaction.providerAmount + transaction.paymentAmount }}</p>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div class="two column row">
                <div class="column">
                  <h4 class="ui header">Client action</h4>

                  <div class="ui inverted segment wrap" v-if="!transaction.refundSignedByServer">
                    <h4 class="ui sub header">Refund transaction (not signed)</h4>
                    <p>{{ transaction.refund }}</p>
                  </div>
                  <div class="ui inverted segment wrap"
                    v-if="transaction.refundSignedByServer && !transaction.refundSignedByServerAndClient">
                    <h4 class="ui sub header">Refund transaction (signed by server)</h4>
                    <p>{{ transaction.refundSignedByServer }}</p>
                  </div>
                  <div class="ui inverted blue secondary segment wrap" v-if="transaction.refundSignedByServerAndClient">
                    <h4 class="ui sub header">Refund transaction (fully signed)</h4>
                    <p>{{ transaction.refundSignedByServerAndClient }}</p>
                  </div>
                  <div class="ui inverted segment wrap"
                    v-if="transaction.postSettlementSignedByServer && !transaction.postSettlementSignedByServerAndClient">
                    <h4 class="ui sub header">Post settlement transaction (signed by server)</h4>
                    <p>{{ transaction.postSettlementSignedByServer }}</p>
                  </div>
                  <div class="ui inverted blue secondary segment wrap" v-if="transaction.postSettlementSignedByServerAndClient">
                    <h4 class="ui sub header">Post settlement transaction (fully signed)</h4>
                    <p>{{ transaction.postSettlementSignedByServerAndClient }}</p>
                  </div>
                  <div class="ui inverted blue secondary segment wrap" v-if="transaction.spendRefund">
                    <h4 class="ui sub header">Spend refund transaction</h4>
                    <p>{{ transaction.spendRefund }}</p>
                  </div>

                  <button class="ui button basic violet"
                    v-if="transaction.refundSignedByServer && !transaction.settlementSignedByClient"
                    @click.prevent="cosignSettlementTransaction(transaction)">Cosign settlement transaction</button>

                  <button class="ui button basic violet"
                    v-if="transaction.settlementSignedByClient && !transaction.refundSignedByServerAndClient"
                    @click.prevent="signRefundTransaction(transaction)">Sign refund transaction</button>

                  <button class="ui button green"
                    v-if="transaction.refundSignedByServerAndClient && !transaction.refundIsSpend"
                    @click.prevent="broadcastRefund(transaction)">Broadcast refund transaction</button>

                  <button class="ui button basic violet"
                    v-if="transaction.settlementSignedByClient && !transaction.postSettlementSignedByServerAndClient"
                    @click.prevent="signPostSettlementTransaction(transaction)">Sign post settlement transaction</button>

                  <button class="ui button green"
                    v-if="transaction.settlementIsSpend && transaction.postSettlementSignedByServerAndClient"
                    @click.prevent="broadcastPostSettlement(transaction)">Broadcast post settlement transaction</button>

                  <button class="ui button"
                    v-if="transaction.refundIsSpend && !transaction.spendRefund"
                    @click.prevent="createSpendRefundTx(transaction)">Create spend refund transaction</button>

                  <button class="ui button green"
                    v-if="transaction.spendRefund && transaction.refundIsSpend"
                    @click.prevent="broadcastSpendRefundTx(transaction)">Broadcast spend refund transaction</button>

                  <div class="ui negative message" v-if="transaction.isClientError">
                    <div class="header">
                      Error during the broadcast
                    </div>
                    <p>{{ transaction.clientError.message }}</p>
                  </div>

                </div>
                <div class="column">
                  <h4 class="ui header">Server action</h4>

                  <div class="ui inverted segment wrap"
                    v-if="transaction.settlement && !transaction.settlementSignedByClient">
                    <h4 class="ui sub header">Settlement transaction (not signed)</h4>
                    <p>{{ transaction.settlement }}</p>
                  </div>
                  <div class="ui inverted segment wrap"
                    v-if="transaction.settlementSignedByClient && !transaction.settlementSignedByClientAndServer">
                    <h4 class="ui sub header">Settlement transaction (signed by client)</h4>
                    <p>{{ transaction.settlementSignedByClient }}</p>
                  </div>
                  <div class="ui inverted red secondary segment wrap" v-if="transaction.settlementSignedByClientAndServer">
                    <h4 class="ui sub header">Settlement transaction (fully signed)</h4>
                    <p>{{ transaction.settlementSignedByClientAndServer }}</p>
                  </div>
                  <div class="ui inverted red secondary segment wrap" v-if="transaction.revokeRefund">
                    <h4 class="ui sub header">Revoke refund transaction</h4>
                    <p>{{ transaction.revokeRefund }}</p>
                  </div>

                  <button class="ui button"
                    v-if="!transaction.refundSignedByServer"
                    @click.prevent="createSettlementTransaction(transaction)">Create settlement transaction</button>

                  <button class="ui button basic violet"
                    v-if="transaction.settlementSignedByClient && !transaction.settlementSignedByClientAndServer"
                    @click.prevent="signSettlementTransaction(transaction)">Sign settlement transaction</button>

                  <button class="ui button green"
                    v-if="transaction.settlementSignedByClientAndServer && !transaction.settlementIsSpend"
                    @click.prevent="broadcastSettlement(transaction)">Broadcast settlement transaction</button>

                  <button class="ui button"
                    v-if="!transaction.revokeRefund && transaction.refundIsSpend && transactions[parseInt(transaction.txIndex)+1] && transactions[parseInt(transaction.txIndex)+1].isComplete"
                    @click.prevent="createRevokeRefundTx(transaction)">Create revoke refund transaction</button>

                  <button class="ui button green"
                    v-if="transaction.revokeRefund && transaction.refundIsSpend && transactions[parseInt(transaction.txIndex)+1] && transactions[parseInt(transaction.txIndex)+1].isComplete"
                    @click.prevent="broadcastRevokeRefundTx(transaction)">Broadcast revoke refund transaction</button>

                  <div class="ui negative message" v-if="transaction.isProviderError">
                    <div class="header">
                      Error during the broadcast
                    </div>
                    <p>{{ transaction.providerError.message }}</p>
                  </div>

                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="column" v-if="transactions.length == 0">
          <p>No transaction yet</p>
        </div>
      </div>

      <div class="row" v-if="channelIsOpen && !channelIsClosing">
        <div class="column">
          <h2 class="ui header">Channel state</h2>
        </div>
      </div>
      <div class="two column row" v-if="channelIsOpen && !channelIsClosing">
        <div class="column">
          <div class="ui segment">
            <form class="ui form">
              <div class="field">
                <label>Send satoshis throught the channel</label>
                <div class="ui left icon input">
                  <i class="btc icon"></i>
                  <input type="text" name="new-balance" placeholder="e.g 2000000" v-model="send.newPaymentAmount">
                </div>
              </div>
              <button class="ui button primary"
                v-bind:class="{ disabled: !isLastTransactionComplete || isSomeTransactionRefund || remainingChannelAmount <= 0 }"
                @click.prevent="sendAmount">Send payment</button>
            </form>
          </div>
        </div>
        <div class="column">
          <div class="ui inverted segment">
            <div class="ui horizontal inverted tiny statistics">
              <div class="statistic">
                <div class="value">
                  {{ remainingChannelAmount }}
                </div>
                <div class="label">
                  remaining satoshis in channel
                </div>
              </div>
              <div class="statistic">
                <div class="value">
                  {{ send.providerAmount }}
                </div>
                <div class="label">
                  satoshis for the provider
                </div>
              </div>
            </div>
          </div>

          <button class="ui labeled icon button"
            @click.prevent="refreshChannelAmount"
            v-bind:class="{ loading: refreshChannel }">
            <i class="refresh icon"></i>
            Refresh remaining satoshis
          </button>
        </div>
      </div>

      <div class="ui section divider" v-if="channelIsOpen"></div>
      <div class="row" v-if="channelIsOpen">
        <div class="column">
          <h2 class="ui header" v-if="!channelIsClosing">Close the channel</h2>
          <h2 class="ui header" v-if="channelIsClosing">Channel is closing</h2>
        </div>
      </div>
      <div class="two column divided row" v-if="channelIsOpen">
        <div class="column">
          <h4 class="ui header">Client action</h4>

          <button class="ui button green"
            v-if="channelIsOpen"
            v-bind:class="{ disabled: opening.isRefund || !funding.refundSignedByServerAndClient }"
            @click.prevent="broadcastRefundOpening">Broadcast refund transaction</button>

          <button class="ui button"
            v-if="channelIsOpen"
            v-bind:class="{ disabled: !opening.isRefund || funding.spendRefund, loading: funding.isCreatingSpendRefund}"
            @click.prevent="createSpendRefund">Create spend refund</button>

          <div class="ui inverted blue secondary segment wrap" v-if="funding.spendRefund && funding.spendRefund.tx">
            <h4 class="ui sub header">Spend refund transaction (fully signed)</h4>
            <p>{{ funding.spendRefund.tx }}</p>
          </div>

          <button class="ui button green"
            v-if="funding.spendRefund && funding.spendRefund.tx"
            v-bind:class="{ disabled: funding.isSpendRefund, loading: funding.pending }"
            @click.prevent="broadcastSpendRefund">Broadcast spend refund</button>

          <div class="ui negative message" v-if="funding.isRefundError">
            <div class="header">
              Error during the broadcast
            </div>
            <p>{{ funding.refundError.message }}</p>
          </div>

        </div>
        <div class="column">
          <h4 class="ui header">Provider action</h4>

          <form class="ui form" v-if="!isFirstTransactionComplete">
            <div class="ui message">
              <div class="header">
                Revoke the refund transaction
              </div>
              <p>This action is not possible in reality because the server doesn't know the revokation secret for the first transaction.
                For testing purpose you can unlock the secret and broadcast the revokation transaction.</p>
            </div>
            <div class="field">
              <div class="ui checkbox">
                <input class="hidden"
                  type="checkbox"
                  v-model="funding.unlockRevoke">
                <label>Unlock the revoke refund transaction</label>
              </div>
            </div>
          </form>
          <div class="ui hidden divider" v-if="!isFirstTransactionComplete"></div>

          <button class="ui button"
            v-if="channelIsOpen"
            v-bind:class="{ disabled: !((opening.isRefund && funding.unlockRevoke) || (opening.isRefund && isFirstTransactionComplete)), loading: funding.isCreatingRevokeRefund }"
            @click.prevent="createRevokeRefund">Create revoke refund</button>

          <div class="ui inverted blue secondary segment wrap" v-if="funding.revokeRefund && funding.revokeRefund.tx">
            <h4 class="ui sub header">Spend revoke transaction (fully signed)</h4>
            <p>{{ funding.revokeRefund.tx }}</p>
          </div>

          <button class="ui button green"
            v-if="funding.revokeRefund && funding.revokeRefund.tx"
            v-bind:class="{ disabled: funding.isSpendRefund, loading: funding.pendingRevoke }"
            @click.prevent="broadcastRevokeRefund">Broadcast revoke refund</button>

          <div class="ui negative message" v-if="funding.isRevokeError">
            <div class="header">
              Error during the broadcast
            </div>
            <p>{{ funding.revokeError.message }}</p>
          </div>

        </div>
      </div>

    </div>
  </div>
</template>

<script>
import bitcoinjs from 'bitcoinjs-lib'
import store from 'browser-store'
import channel from '../../dist/channel.js'

export default {
  name: 'app',
  components: {},

  data: function () {
    return {
      channel: undefined,
      channelKernel: undefined,
      serverChannel: undefined,
      serverKernel: undefined,
      network: undefined,
      channelIsSetup: false,
      channelIsReseting: false,
      channelIsOpen: false,
      channelIsClosing: false,
      refreshChannel: false,
      restored: {},
      settings: {
        network: '',
        accountId: undefined,
        blocksInFuture: undefined,
        feePerByte: undefined,
        clientSeed: '',
        clientAccPubkey: '',
        providerSeed: '',
        providerAccPubkey: '',
        isLoading: false,
        storing: false
      },
      opening: {
        pending: false,
        refreshing: false,
        broadcastingProviderToClient: false,
        isRefund: false,
        loadingProviderUtxos: false,
        path: 1,
        address: '',
        wif: undefined,
        i: '',
        n: '',
        multisig: {},
        provider: {
          utxos: [],
          amount: 0,
          path: 1,
          address: '',
          wif: undefined
        },
        amount: 0,
        sendToExitAddress: false,
        exitAddress: undefined,
        utxos: []
      },
      funding: {
        transaction: undefined,
        refundSignedByServer: undefined,
        refundSignedByServerAndClient: undefined,
        spendRefund: undefined,
        isSpendRefund: false,
        isCreatingSpendRefund: false,
        isCreatingRevokeRefund: false,
        revokeRefund: undefined,
        unlockRevoke: false,
        isRefundError: false,
        refundError: undefined,
        isRevokeError: false,
        revokeError: undefined,
        pendingRevoke: false,
        pending: false
      },
      send: {
        current: {
          i: undefined,
          n: undefined
        },
        totalInChannel: 0,
        newPaymentAmount: 10000,
        providerAmount: 0
      },
      transactions: []
    }
  },

  mounted: function () {
    let fn = () => {
      $('.ui.dropdown').dropdown()
      $('.button').popup()
      $('.ui.checkbox').checkbox()
    }
    setTimeout(fn, 500)
    // setInterval(fn, 5000)

    store.get('settings', (err, value) => {
      if (err) {
        this.restored = {}
      }

      this.restored = value
    })
  },

  methods: {

    // =========================================================================
    // SETTINGS FUNC
    // =========================================================================

    storeSettings: function () {
      this.settings.storing = true
      store.put('settings', this.settings, () => {
        this.settings.storing = false
        alert('Settings stored')
      })
    },

    removeSaves: function () {
      if (confirm('Remove all saved values?')) {
        this.close()
        store.clear()
      }
    },

    loadSettings: function () {
      this.settings = Object.assign(this.settings, this.restored)
      $('.ui.dropdown').dropdown('set selected', this.settings.network)
      this.settings.isLoading = false
      this.settings.storing = false

      let fn = () => {
        $('.ui.dropdown').dropdown()
        $('.button').popup()
        $('.ui.checkbox').checkbox()
      }
      setTimeout(fn, 500)
    },

    seeds: function () {
      this.settings.clientSeed = channel.Client.generateSeed(this.network)
      this.settings.providerSeed = channel.Server.generateSeed(this.network)
    },

    refreshSeeds: function () {
      this.settings.clientAccPubkey =
        bitcoinjs.HDNode.fromBase58(
            this.settings.clientSeed,
            this.network)
          .deriveHardened(44)
          .deriveHardened(0)
          .deriveHardened(parseInt(this.settings.accountId))
          .neutered()
          .toBase58()

      this.settings.providerAccPubkey =
        bitcoinjs.HDNode.fromBase58(
            this.settings.providerSeed,
            this.network)
          .deriveHardened(44)
          .deriveHardened(0)
          .deriveHardened(parseInt(this.settings.accountId))
          .neutered()
          .toBase58()
    },

    setup: function () {
      this.settings.isLoading = true

      this.channel = new channel.Client()
      this.channelKernel = new channel.Kernel(
        this.settings.clientSeed,
        this.settings.providerAccPubkey,
        parseInt(this.settings.accountId),
        this.settings.network,
        'insight',
        parseInt(this.settings.blocksInFuture)
      )

      this.serverChannel = new channel.Server()
      this.serverKernel = new channel.Kernel(
        this.settings.clientAccPubkey,
        this.settings.providerSeed,
        parseInt(this.settings.accountId),
        this.settings.network,
        'insight',
        parseInt(this.settings.blocksInFuture)
      )

      this.addresses()

      store.get('openChannel', (err, value) => {
        if (err) {
          throw new Error(err)
        }

        if (value !== null) {
          this.opening = Object.assign(this.opening, value.opening)
          this.funding = Object.assign(this.funding, value.funding)
          this.channelIsOpen = true
          this.addresses()
          this.refreshChannelAmount()
        }
      })

      store.get('isRefund', (err, value) => {
        if (err) {
          throw new Error(err)
        }

        if (value !== null) {
          this.opening.isRefund = value
          if (this.opening.isRefund) {
            this.channelIsClosing = true
          }
        }
      })

      this.channelIsSetup = true
      this.settings.isLoading = false

      let fn = () => {
        $('.ui.dropdown').dropdown()
        $('.button').popup()
        $('.ui.checkbox').checkbox()
      }
      setTimeout(fn, 2500)
    },

    close: function () {
      localStorage.removeItem('isRefund')
      localStorage.removeItem('openChannel')
      this.restored = undefined
      this.channelIsOpen = false
      this.channelIsClosing = false
      this.channelIsSetup = false
      this.channelIsReseting = false
      this.opening = {
        pending: false,
        refreshing: false,
        broadcastingProviderToClient: false,
        isRefund: false,
        loadingProviderUtxos: false,
        path: 1,
        address: '',
        wif: undefined,
        i: '',
        n: '',
        multisig: {},
        provider: {
          utxos: [],
          amount: 0,
          path: 1,
          address: '',
          wif: undefined
        },
        amount: 0,
        utxos: []
      }
      this.funding = {
        transaction: undefined,
        refundSignedByServer: undefined,
        refundSignedByServerAndClient: undefined,
        spendRefund: undefined,
        isSpendRefund: false,
        isCreatingSpendRefund: false,
        isCreatingRevokeRefund: false,
        revokeRefund: undefined,
        unlockRevoke: false,
        isRefundError: false,
        refundError: undefined,
        isRevokeError: false,
        revokeError: undefined,
        pendingRevoke: false,
        pending: false
      }
      this.send = {
        current: {
          i: undefined,
          n: undefined
        },
        totalInChannel: 0,
        newPaymentAmount: 10000,
        providerAmount: 0
      }
      this.transactions = []
    },

    resetChannel: function () {
      this.channelIsReseting = true
      this.channelKernel
        .getAdapter()
        .getUtxos(this.opening.multisig.address).then((utxos) => {
          let bytes = 10
          let txb = new bitcoinjs.TransactionBuilder(this.network)
          let i = {
            flatten: () => parseInt(this.opening.i)
          }
          let multisig = this.channelKernel.multisig.deriveContract(i)
          let client = this.channelKernel.multisig.getKeyPair(i)
          client.network = this.network
          let provider = this.serverKernel.multisig.getKeyPair(i)
          provider.network = this.network
          txb.setVersion(1)
          utxos.forEach((utxo) => {
            txb.addInput(utxo.txid, utxo.vout)
            bytes += 180
          })
          let btc = utxos.reduce((acc, utxo) =>
            acc.add(utxo.amount),
            channel.Btc.zero())
          let fees = btc.sub(channel.Btc.fromSatoshis(bytes * this.settings.feePerByte))
          txb.addOutput(this.opening.address, fees.satoshis())
          utxos.forEach((utxo, i) => {
            txb.sign(i, client, multisig.redeemScript)
            txb.sign(i, provider, multisig.redeemScript)
          })
          this.channelKernel
            .getAdapter()
            .broadcastTx(txb.build().toHex()).then((res) => {
              this.close()
              this.channelIsReseting = false
            })
        })
    },

    // =========================================================================
    // SETUP FUNC
    // =========================================================================

    addresses: function () {
      let cnode = bitcoinjs.HDNode.fromBase58(
          this.settings.clientSeed,
          this.network)
          .derivePath("m/44'/0'/1'/0/" + this.opening.path)
      this.opening.address = cnode.getAddress()
      this.opening.wif = cnode.keyPair.toWIF()

      let pnode = bitcoinjs.HDNode.fromBase58(
          this.settings.providerSeed,
          this.network)
          .derivePath("m/44'/0'/1'/0/" + this.opening.provider.path)
      this.opening.provider.address = pnode.getAddress()
      this.opening.provider.wif = pnode.keyPair.toWIF()
    },

    refreshFunding: function () {
      this.opening.refreshing = true
      this.channelKernel.getAdapter().getUtxos(this.opening.address).then((res) => {
        this.opening.utxos = res
        let btc = res.reduce((acc, utxo) =>
          acc.add(utxo.amount),
          channel.Btc.zero())
        this.opening.amount = btc.satoshis()
        this.opening.refreshing = false
      })
    },

    getProviderUtxos: function () {
      this.opening.loadingProviderUtxos = true
      this.channelKernel.getAdapter().getUtxos(this.opening.provider.address)
        .then((res) => {
          this.opening.provider.utxos = res
          let btc = res.reduce((acc, utxo) =>
            acc.add(utxo.amount),
            channel.Btc.zero())
          this.opening.provider.amount = btc.satoshis()
          this.opening.loadingProviderUtxos = false
        })
    },

    sendUtxosFromProviderToAddress: function (address) {
      this.opening.broadcastingProviderToClient = true
      let bytes = 44
      let provider = bitcoinjs.ECPair.fromWIF(this.opening.provider.wif, this.network)
      let txb = new bitcoinjs.TransactionBuilder(this.network)
      txb.setVersion(1)
      this.opening.provider.utxos.forEach((utxo) => {
        txb.addInput(utxo.txid, utxo.vout)
        bytes += 180
      })
      let btc = this.opening.provider.utxos.reduce((acc, utxo) =>
        acc.add(utxo.amount),
        channel.Btc.zero())
      let fees = btc.sub(channel.Btc.fromSatoshis(bytes * this.settings.feePerByte))
      txb.addOutput(address, fees.satoshis())
      this.opening.provider.utxos.forEach((utxo, i) => {
        txb.sign(i, provider)
      })
      let tx = txb.build().toHex()
      this.channelKernel
        .getAdapter()
        .broadcastTx(tx).then((res) => {
          this.opening.provider.utxos = []
          this.opening.provider.amount = 0
          this.opening.broadcastingProviderToClient = false
          this.opening.sendToExitAddress = false
        }).catch(e => {
          this.opening.broadcastingProviderToClient = false
          this.opening.sendToExitAddress = false
        })
    },

    // =========================================================================
    // MULFISIG SETTINGS FUNC
    // =========================================================================

    getFirstMultisig: function () {
      this.opening.multisig = this.channelKernel.multisig.deriveContract(
        { flatten: () => parseInt(this.opening.i) }
      )
      this.opening.multisig.asm = bitcoinjs.script.toASM(
        this.opening.multisig.redeemScript
      )
    },

    defaultState: function () {
      this.opening.i = '0'
      this.opening.n = '0'
    },

    // =========================================================================
    // OPENING CHANNEL FUNC
    // =========================================================================

    // ********************  FUNDING TRANSACTION  *****************************
    createFundingTransaction: function () {
      this.funding.pending = true
      let utxoWifs = this.channel.createUtxosAndWifs(
        this.opening.utxos,
        this.opening.wif
      )
      let res = this.channel.createFundingTransaction(
        utxoWifs, // utxosAndWifs
        { flatten: () => parseInt(this.opening.i) }, // i: number
        { flatten: () => parseInt(this.opening.n) }, // n: number
        this.satPerByte,
        this.opening.provider.address, // providerAddress
        this.channelKernel
      )

      this.funding.transaction = res
      this.funding.transaction.revPubkey.asm =
        bitcoinjs.script.toASM(this.funding.transaction.revPubkey.redeemScript)
      this.funding.transaction.revPubkey.redeemScript =
        this.funding.transaction.revPubkey.redeemScript.toString('hex')
      this.funding.transaction.revPubkey.revHash =
        this.funding.transaction.revPubkey.revHash.toString('hex')
      this.funding.transaction.revSecret = this.channelKernel
        .revPubkey
        .deriveRevSecret(
          { flatten: () => parseInt(this.opening.i) },
          { flatten: () => parseInt(this.opening.n) },
        ).toString('hex')
      this.funding.pending = false
    },

    // *****************  BROADCAST FUNDING TRANSACTION  **********************
    open: function () {
      this.opening.pending = true
      this.channelKernel
        .getAdapter()
        .broadcastTx(this.funding.transaction.fundingTx.tx).then((res) => {
          let params = {
            opening: {
              path: this.opening.path,
              provider: {
                path: this.opening.provider.path,
                utxos: [],
                amount: 0,
                address: '',
                wif: this.opening.provider.path
              },
              i: this.opening.i,
              n: this.opening.n,
              isRefund: this.opening.isRefund
            },
            funding: {
              refundSignedByServer: this.funding.refundSignedByServer,
              refundSignedByServerAndClient: this.funding.refundSignedByServerAndClient,
              transaction: {
                channelAddress: this.funding.transaction.channelAddress,
                revHash: this.funding.transaction.revHash,
                fundingTx: this.funding.transaction.fundingTx,
                refundTx: this.funding.transaction.refundTx,
                revPubkey: {
                  address: this.funding.transaction.revPubkey.address,
                  asm: this.funding.transaction.revPubkey.asm,
                  redeemScript: this.funding.transaction.revPubkey.redeemScript,
                  revHash: this.funding.transaction.revPubkey.revHash
                },
                revSecret: this.funding.transaction.revSecret
              }
            }
          }
          store.put('openChannel', params, () => {
            this.channelIsOpen = true
            this.opening.pending = false
          })
          this.refreshChannelAmount()

          let fn = () => {
            $('.ui.dropdown').dropdown()
            $('.button').popup()
            $('.ui.checkbox').checkbox()
          }
          setTimeout(fn, 500)
        })
    },

    // *********************  REFUND TRANSACTION  *****************************
    signRefundByServer: function () {
      let txb = this.serverChannel.signRefundTransaction(
        this.funding.transaction.refundTx.tx,
        { flatten: () => parseInt(this.opening.i) }, // i: number
        this.serverKernel
      )
      this.funding.refundSignedByServer = txb.buildIncomplete().toHex()
    },

    signRefundByClient: function () {
      let txb = this.channel.cosignRefundTransaction(
        this.funding.refundSignedByServer,
        { flatten: () => parseInt(this.opening.i) }, // i: number
        this.channelKernel
      )
      this.funding.refundSignedByServerAndClient = txb.buildIncomplete().toHex()
    },

    broadcastRefundOpening: function () {
      this.opening.pending = true
      this.channelKernel
        .getAdapter()
        .broadcastTx(this.funding.refundSignedByServerAndClient).then((res) => {
          this.opening.isRefund = true
          this.channelIsClosing = true
          store.put('isRefund', this.opening.isRefund, () => {
            this.opening.pending = false
          })
        })
    },

    // *********************  SPEND REFUND TRANSACTION  ***********************
    createSpendRefund: function () {
      this.funding.isCreatingSpendRefund = true
      this.channelKernel
        .getAdapter()
        .getUtxos(this.funding.transaction.revPubkey.address).then((utxos) => {
          let utxosAndWifs = this.channel.createUtxosAndWifs(
            utxos,
            this.channelKernel.revPubkey.getKeyPair({
              flatten: () => parseInt(this.opening.i)
            }).toWIF()
          )
          let spendRefund = this.channel.createSpendRefundTransaction(
            utxosAndWifs,
            { flatten: () => parseInt(this.opening.i) },
            { flatten: () => parseInt(this.opening.n) },
            this.satPerByte,
            this.opening.address,
            this.channelKernel
          )
          this.funding.spendRefund = spendRefund
          this.funding.isCreatingSpendRefund = false
        })
    },

    broadcastSpendRefund: function () {
      this.funding.pending = true
      this.funding.isRefundError = false
      this.channelKernel
        .getAdapter()
        .broadcastTx(this.funding.spendRefund.tx).then((res) => {
          this.funding.isSpendRefund = true
          this.funding.pending = false
          this.funding.isRefundError = false
          this.close()
        }).catch(e => {
          this.funding.pending = false
          this.funding.isRefundError = true
          this.funding.refundError = e
        })
    },

    // *********************  REVOKE REFUND TRANSACTION  **********************
    createRevokeRefund: function () {
      this.funding.isCreatingRevokeRefund = true
      this.serverKernel
        .getAdapter()
        .getUtxos(this.funding.transaction.revPubkey.address).then((utxos) => {
          let utxosAndWifs = this.channel.createUtxosAndWifs(
            utxos,
            this.serverKernel.revPubkey.getKeyPair({
              flatten: () => parseInt(this.opening.i)
            }).toWIF()
          )

          let previousSecret = this.channelKernel.revPubkey.deriveRevSecret(
            { flatten: () => parseInt(this.opening.i) },
            { flatten: () => parseInt(this.opening.n) },
          )
          let revokeRefund =
            this.serverChannel.createRevokeRefund(
              utxosAndWifs,
              { flatten: () => parseInt(this.opening.i) },
              this.satPerByte,
              this.opening.provider.address,
              previousSecret,
              this.serverKernel
            )
          this.funding.revokeRefund = revokeRefund
          this.funding.isCreatingRevokeRefund = false
        })
    },

    broadcastRevokeRefund: function () {
      this.funding.isRevokeError = false
      this.funding.pendingRevoke = true
      this.channelKernel
        .getAdapter()
        .broadcastTx(this.funding.revokeRefund.tx).then((res) => {
          this.funding.pendingRevoke = false
          this.funding.isSpendRefund = true
          this.funding.isRevokeError = false
          this.close()
        }).catch(e => {
          this.funding.pendingRevoke = false
          this.funding.isRevokeError = true
          this.funding.revokeError = e
        })
    },

    // =========================================================================
    // TRANSACTING THROUGHT CHANNEL
    // =========================================================================

    refreshChannelAmount: function () {
      this.refreshChannel = true
      this.channelKernel.getAdapter().getUtxos(this.getCurrentMultisig.address)
        .then((res) => {
          let btc = res.reduce((acc, utxo) =>
            acc.add(utxo.amount),
            channel.Btc.zero())
          this.send.totalInChannel = btc.satoshis()
          this.refreshChannel = false
        })
    },

    sendAmount: function () {
      if (parseInt(this.send.newPaymentAmount) >= 10000) {
        if (typeof this.send.current.i === 'undefined' || typeof this.send.current.n === 'undefined') {
          this.send.current.i = parseInt(this.opening.i)
          this.send.current.n = parseInt(this.opening.n) + 1
        } else {
          this.send.current.n += 1
        }

        let i = channel.newI(this.send.current.i)
        let n = channel.newN(this.send.current.n)
        const state = {
          txIndex: this.transactions.length,
          i: i,
          n: n,
          isComplete: false,
          refundIsSpend: false,
          settlementIsSpend: false,
          utxos: [],
          refund: undefined,
          refundSignedByServer: undefined,
          refundSignedByServerAndClient: undefined,
          postSettlementSignedByServer: undefined,
          postSettlementSignedByServerAndClient: undefined,
          postSettlementIsSpend: false,
          settlement: undefined,
          settlementSignedByClient: undefined,
          settlementSignedByClientAndServer: undefined,
          isCreatingSpendRefund: false,
          spendRefund: undefined,
          isCreatingRevokeRefund: false,
          revokeRefund: undefined,
          currentSecret: undefined,
          previousSecret: undefined,
          revPubkey: undefined,
          paymentAmount: parseInt(this.send.newPaymentAmount),
          providerAmount: 0,
          nextMultisig: undefined,
          isClientError: false,
          clientError: undefined,
          isProviderError: false,
          providerError: undefined,
          refundPending: false,
          spendRefundPending: false,
          revokeRefundPending: false,
          settlementPending: false,
          postSettlementPending: false
        }

        this.channelKernel
          .getAdapter()
          .getUtxos(this.opening.multisig.address).then((utxos) => {
            let newProviderBalance = channel.Btc.fromSatoshis(parseInt(this.send.providerAmount))
              .add(channel.Btc.fromSatoshis(parseInt(this.send.newPaymentAmount)))
            let newClientBalance = channel.Btc.fromSatoshis(parseInt(this.send.totalInChannel))
              .sub(newProviderBalance)
            let init = this.channel.initiateTransaction(
              utxos,
              i,
              n,
              newProviderBalance,
              newClientBalance,
              this.satPerByte,
              this.opening.provider.address,
              this.channelKernel
            )

            state.utxos = utxos
            state.refund = init.refundTx.tx
            state.revPubkey = init.revPubkey
            state.revPubkey = init.revPubkey
            state.providerAmount = this.send.providerAmount

            state.revPubkey.asm = bitcoinjs.script.toASM(
              state.revPubkey.redeemScript
            )
            state.revPubkey.revHash = state.revPubkey.revHash.toString('hex')
            state.revPubkey.redeemScript = state.revPubkey.redeemScript.toString('hex')

            state.nextMultisig = this.channelKernel.multisig.deriveContract(i.next())
            state.nextMultisig.asm = bitcoinjs.script.toASM(
              state.nextMultisig.redeemScript
            )
            state.nextMultisig.redeemScript = state.nextMultisig.redeemScript.toString('hex')

            state.currentSecret = this.channelKernel.revPubkey.deriveRevSecret(
              i,
              n
            ).toString('hex')

            this.send.newPaymentAmount = 10000
            this.transactions.push(state)
          })
      } else {
        alert('You need to send minimum 10000 satoshis!')
      }
    },

    createSettlementTransaction: function (transaction) {
      let providerAmount = channel.Btc.fromSatoshis(
        transaction.providerAmount + transaction.paymentAmount
      )
      let inChannel = transaction.utxos.reduce((acc, utxo) =>
        acc.add(utxo.amount),
        channel.Btc.zero())
      let changeAmount = inChannel.sub(providerAmount)

      let settlement = this.serverChannel.createSettlementTransaction(
        transaction.utxos,
        transaction.i,
        transaction.n,
        transaction.refund,
        transaction.revPubkey.revHash,
        this.opening.provider.address,
        providerAmount,
        changeAmount,
        this.satPerByte,
        this.serverKernel
      )

      transaction.postSettlementSignedByServer = settlement.postSettlementTxHex
      transaction.refundSignedByServer = settlement.refundTxHex
      transaction.settlement = settlement.settlementTxHex
    },

    cosignSettlementTransaction: function (transaction) {
      let res = this.channel.signSettlementTransaction(
        transaction.i,
        transaction.n,
        transaction.settlement,
        this.channelKernel
      )
      transaction.previousSecret = res.previousRevSecret.toString('hex')
      transaction.settlementSignedByClient = res.settlementTxHex
      transaction.isComplete = true

      this.send.providerAmount += transaction.paymentAmount
    },

    signRefundTransaction: function (transaction) {
      transaction.refundSignedByServerAndClient = this.channel.cosignRefundTransaction(
        transaction.refundSignedByServer,
        transaction.i,
        this.channelKernel
      ).build().toHex()
    },

    signPostSettlementTransaction: function (transaction) {
      transaction.postSettlementSignedByServerAndClient = this.channel
        .signPostSettlementRefundTransaction(
          transaction.postSettlementSignedByServer,
          transaction.i
        ).build().toHex()
    },

    signSettlementTransaction: function (transaction) {
      transaction.settlementSignedByClientAndServer = this.serverChannel.cosignSettlementTransaction(
        transaction.settlementSignedByClient,
        transaction.i,
        this.serverKernel,
      )
    },

    broadcastRefund: function (transaction) {
      transaction.isClientError = false
      transaction.refundPending = true
      this.channelKernel
        .getAdapter()
        .broadcastTx(transaction.refundSignedByServerAndClient).then((res) => {
          transaction.refundPending = false
          transaction.refundIsSpend = true
          this.channelIsClosing = true
          transaction.isClientError = false
        }).catch(e => {
          transaction.refundPending = false
          transaction.isClientError = true
          transaction.clientError = e
        })
    },

    broadcastSettlement: function (transaction) {
      transaction.settlementPending = true
      transaction.isProviderError = false
      this.serverKernel
        .getAdapter()
        .broadcastTx(transaction.settlementSignedByClientAndServer).then((res) => {
          transaction.settlementPending = false
          transaction.settlementIsSpend = true
          this.channelIsClosing = true
          transaction.isProviderError = false
        }).catch(e => {
          transaction.settlementPending = false
          transaction.isProviderError = true
          transaction.providerError = e
        })
    },

    broadcastPostSettlement: function (transaction) {
      transaction.postSettlementPending = true
      transaction.isProviderError = false
      this.serverKernel
        .getAdapter()
        .broadcastTx(transaction.postSettlementSignedByServerAndClient).then((res) => {
          transaction.postSettlementPending = false
          transaction.isProviderError = false
        }).catch(e => {
          transaction.postSettlementPending = false
          transaction.isProviderError = true
          transaction.providerError = e
        })
    },

    // *********************  SPEND REFUND TRANSACTION  ***********************
    createSpendRefundTx: function (transaction) {
      transaction.isCreatingSpendRefund = true
      this.channelKernel
        .getAdapter()
        .getUtxos(transaction.revPubkey.address).then((utxos) => {
          let utxosAndWifs = this.channel.createUtxosAndWifs(
            utxos,
            this.channelKernel.revPubkey.getKeyPair(transaction.i).toWIF()
          )
          let spendRefund = this.channel.createSpendRefundTransaction(
            utxosAndWifs,
            transaction.i,
            transaction.n,
            this.satPerByte,
            this.opening.address,
            this.channelKernel
          )
          transaction.spendRefund = spendRefund.tx
          transaction.isCreatingSpendRefund = false
        })
    },

    broadcastSpendRefundTx: function (transaction) {
      transaction.spendRefundPending = true
      transaction.isClientError = false
      this.channelKernel
        .getAdapter()
        .broadcastTx(transaction.spendRefund).then((res) => {
          transaction.spendRefundPending = false
          transaction.isClientError = false
          this.close()
        }).catch(e => {
          transaction.spendRefundPending = false
          transaction.isClientError = true
          transaction.clientError = e
        })
    },

    // *********************  REVOKE REFUND TRANSACTION  **********************
    createRevokeRefundTx: function (transaction) {
      transaction.isCreatingRevokeRefund = true
      this.serverKernel
        .getAdapter()
        .getUtxos(transaction.revPubkey.address).then((utxos) => {
          let utxosAndWifs = this.channel.createUtxosAndWifs(
            utxos,
            this.serverKernel.revPubkey.getKeyPair(transaction.i).toWIF()
          )
          let currentSecret = this.channelKernel
            .revPubkey.deriveRevSecret(transaction.i, transaction.n)
          let revokeRefund =
            this.serverChannel.createRevokeRefund(
              utxosAndWifs,
              transaction.i,
              this.satPerByte,
              this.opening.provider.address,
              currentSecret,
              this.serverKernel
            )
          transaction.revokeRefund = revokeRefund.tx
          transaction.isCreatingRevokeRefund = false
        })
    },

    broadcastRevokeRefundTx: function (transaction) {
      transaction.revokeRefundPending = true
      transaction.isProviderError = false
      this.channelKernel
        .getAdapter()
        .broadcastTx(transaction.revokeRefund).then((res) => {
          transaction.revokeRefundPending = false
          transaction.isProviderError = false
          this.close()
        }).catch(e => {
          transaction.revokeRefundPending = false
          transaction.isProviderError = true
          transaction.providerError = e
        })
    }
  },

  computed: {
    remainingChannelAmount: function () {
      return this.send.totalInChannel - this.send.providerAmount
    },

    getCurrentMultisig: function () {
      let ms = this.channelKernel.multisig.deriveContract(
        channel.newI(parseInt(this.opening.i))
      )
      ms.asm = bitcoinjs.script.toASM(
        ms.redeemScript
      )
      return ms
    },

    satPerByte: function () {
      return channel.Btc.fromSatoshis(parseInt(this.settings.feePerByte))
    },

    isSettingsComplete: function () {
      return this.settings.network &&
        this.settings.accountId &&
        this.settings.blocksInFuture &&
        this.settings.feePerByte
    },

    isLastTransactionComplete: function () {
      if (this.transactions.length === 0) {
        return true
      } else {
        let last = this.transactions.slice(-1).pop()
        return last.isComplete
      }
    },

    isSomeTransactionRefund: function () {
      if (this.transactions.length === 0) {
        return this.opening.isRefund
      } else {
        return this.transactions.reduce((acc, tx) => acc || tx.refundIsSpend, false)
      }
    },

    isFirstTransactionComplete: function () {
      if (this.transactions.length >= 1) {
        return this.transactions[0].isComplete
      } else {
        return false
      }
    },

    openingBtc: function () {
      return channel.Btc.fromSatoshis(this.opening.amount).bitcoin()
    }
  },

  watch: {
    'settings.network': function (newValue) {
      switch (newValue) {
        case 'bitcoin':
          this.network = bitcoinjs.networks.bitcoin
          break
        case 'testnet':
          this.network = bitcoinjs.networks.testnet
          break
        default:
          this.network = bitcoinjs.networks.testnet
      }
    },

    'settings.clientSeed': function (newValue) {
      this.settings.clientAccPubkey =
        bitcoinjs.HDNode.fromBase58(
            this.settings.clientSeed,
            this.network)
          .deriveHardened(44)
          .deriveHardened(0)
          .deriveHardened(parseInt(this.settings.accountId))
          .neutered()
          .toBase58()
    },

    'settings.providerSeed': function (newValue) {
      this.settings.providerAccPubkey =
        bitcoinjs.HDNode.fromBase58(
            this.settings.providerSeed,
            this.network)
          .deriveHardened(44)
          .deriveHardened(0)
          .deriveHardened(parseInt(this.settings.accountId))
          .neutered()
          .toBase58()
    },

    'opening.path': function (newValue) {
      this.opening.address = bitcoinjs.HDNode.fromBase58(
          this.settings.clientSeed,
          this.network)
          .derivePath("m/44'/0'/1'/0/" + newValue)
          .getAddress()
    },

    'opening.provider.path': function (newValue) {
      this.opening.provider.address = bitcoinjs.HDNode.fromBase58(
          this.settings.providerSeed,
          this.network)
          .derivePath("m/44'/0'/1'/0/" + newValue)
          .getAddress()
    },

    'opening.i': function (newValue) {
      if (this.opening.n && newValue) {
        this.getFirstMultisig()
        this.refreshChannelAmount()
      }
    },

    'opening.n': function (newValue) {
      if (this.opening.i && newValue) {
        this.getFirstMultisig()
        this.refreshChannelAmount()
      }
    }
  }
}
</script>

<style scoped>
#app {
  padding: 25px;
  max-width: 1500px !important;
}

.wrap {
  word-wrap: break-word;
  word-break: break-all;
}

.no-padding {
  padding: 0;
}

.align-center {
  text-align: center;
}

.full {
  width: 100%;
}
</style>
